var $AdfSubIdUtils$$ = {};
$goog$exportSymbol$$("AdfSubIdUtils", $AdfSubIdUtils$$);
$AdfSubIdUtils$$.$getSubIdElementById$ = function $$AdfSubIdUtils$$$$getSubIdElementById$$($component$$2504_domElement$$709_subId$$72$$, $subElementId$$75$$, $isNC$$1$$) {
  $AdfAssert$$.$assertNonEmptyString$($subElementId$$75$$);
  $AdfAssert$$.assert($component$$2504_domElement$$709_subId$$72$$);
  $component$$2504_domElement$$709_subId$$72$$ = $isNC$$1$$ ? $component$$2504_domElement$$709_subId$$72$$.$getClientId$() + ":" + $subElementId$$75$$ : $AdfRichUIPeer$$.$CreateSubId$($component$$2504_domElement$$709_subId$$72$$.$getClientId$(), $subElementId$$75$$);
  return ($component$$2504_domElement$$709_subId$$72$$ = $AdfAgent$$.$getAgent$().getElementById($component$$2504_domElement$$709_subId$$72$$)) ? $component$$2504_domElement$$709_subId$$72$$ : null;
};
$AdfSubIdUtils$$.getSubIdElementById = $AdfSubIdUtils$$.$getSubIdElementById$;
$goog$exportSymbol$$("AdfSubIdUtils.getSubIdElementById", $AdfSubIdUtils$$.$getSubIdElementById$);
$AdfSubIdUtils$$.$getSubIdDomElementDelegateSuper$ = function $$AdfSubIdUtils$$$$getSubIdDomElementDelegateSuper$$($subElementId$$76$$, $subIdMap$$6$$, $component$$2505$$, $domElem$$21_peer$$241$$, $theClass$$13$$) {
  $AdfAssert$$.$assertNonEmptyString$($subElementId$$76$$);
  return ($domElem$$21_peer$$241$$ = $theClass$$13$$.$superclass$.$GetSubIdDomElement$.call($domElem$$21_peer$$241$$, $subElementId$$76$$)) ? $domElem$$21_peer$$241$$ : $AdfSubIdUtils$$.$getSubIdDomElementByMappedSubId$($subElementId$$76$$, $subIdMap$$6$$, $component$$2505$$);
};
$goog$exportSymbol$$("AdfSubIdUtils.getSubIdDomElementDelegateSuper", $AdfSubIdUtils$$.$getSubIdDomElementDelegateSuper$);
$AdfSubIdUtils$$.$getSubIdDomElementByMappedSubId$ = function $$AdfSubIdUtils$$$$getSubIdDomElementByMappedSubId$$($clientSubId$$9_subElementId$$77$$, $subIdMap$$7$$, $component$$2506$$) {
  $AdfAssert$$.$assertNonEmptyString$($clientSubId$$9_subElementId$$77$$);
  return ($clientSubId$$9_subElementId$$77$$ = $subIdMap$$7$$[$clientSubId$$9_subElementId$$77$$]) ? (null == $component$$2506$$ && ($component$$2506$$ = this.$getComponent$()), $AdfSubIdUtils$$.$getSubIdElementById$($component$$2506$$, $clientSubId$$9_subElementId$$77$$)) : null;
};
$AdfSubIdUtils$$.getSubIdDomElementByMappedSubId = $AdfSubIdUtils$$.$getSubIdDomElementByMappedSubId$;
$goog$exportSymbol$$("AdfSubIdUtils.getSubIdDomElementByMappedSubId", $AdfSubIdUtils$$.$getSubIdDomElementByMappedSubId$);
$AdfSubIdUtils$$.$getBestMatchSubIdDelegateSuper$ = function $$AdfSubIdUtils$$$$getBestMatchSubIdDelegateSuper$$($domElement$$710$$, $peer$$242$$, $subIdMap$$8$$, $subid$$17_theClass$$14$$) {
  return ($subid$$17_theClass$$14$$ = $subid$$17_theClass$$14$$.$superclass$.$GetBestMatchSubId$.call($peer$$242$$, $domElement$$710$$)) ? $subid$$17_theClass$$14$$ : $AdfSubIdUtils$$.$getBestMatchSubId$($domElement$$710$$, $peer$$242$$, $subIdMap$$8$$);
};
$goog$exportSymbol$$("AdfSubIdUtils.getBestMatchSubIdDelegateSuper", $AdfSubIdUtils$$.$getBestMatchSubIdDelegateSuper$);
$AdfSubIdUtils$$.$getBestMatchSubId$ = function $$AdfSubIdUtils$$$$getBestMatchSubId$$($domElement$$711$$, $peer$$243$$, $subDomElement_subIdMap$$9$$) {
  $AdfAssert$$.$assertDomElement$($domElement$$711$$);
  for (var $bestMatchCount_rootDomElement$$26$$ = $peer$$243$$.$getDomElement$(), $count$$45_upCount$$1$$ = 0, $element$$404$$ = $domElement$$711$$;$element$$404$$ && $element$$404$$ != $bestMatchCount_rootDomElement$$26$$;) {
    $count$$45_upCount$$1$$++, $element$$404$$ = $element$$404$$.parentNode;
  }
  if ($subDomElement_subIdMap$$9$$) {
    var $bestMatchCount_rootDomElement$$26$$ = $count$$45_upCount$$1$$, $bestMatchSubId$$2$$, $currSubId$$;
    for ($currSubId$$ in $subDomElement_subIdMap$$9$$) {
      if ($subDomElement_subIdMap$$9$$ = $peer$$243$$.$GetSubIdDomElement$($currSubId$$)) {
        for ($element$$404$$ = $domElement$$711$$, $count$$45_upCount$$1$$ = 0;$count$$45_upCount$$1$$ < $bestMatchCount_rootDomElement$$26$$;$count$$45_upCount$$1$$++) {
          if ($element$$404$$ == $subDomElement_subIdMap$$9$$) {
            $bestMatchCount_rootDomElement$$26$$ = $count$$45_upCount$$1$$;
            $bestMatchSubId$$2$$ = $currSubId$$;
            break;
          }
          $element$$404$$ = $element$$404$$.parentNode;
        }
      }
      if (0 == $bestMatchCount_rootDomElement$$26$$) {
        break;
      }
    }
    return $bestMatchSubId$$2$$;
  }
  return null;
};
$goog$exportSymbol$$("AdfSubIdUtils.getBestMatchSubId", $AdfSubIdUtils$$.$getBestMatchSubId$);
$AdfSubIdUtils$$.$getChildElementByAttributeValue$ = function $$AdfSubIdUtils$$$$getChildElementByAttributeValue$$($domElement$$712$$, $attrName$$16$$, $attrValue$$29$$, $tagName$$25$$) {
  return $AdfDomUtils$$.$getChildElementByAttributeValue$($domElement$$712$$, $attrName$$16$$, $attrValue$$29$$, $tagName$$25$$);
};
$AdfSubIdUtils$$.getChildElementByAttributeValue = $AdfSubIdUtils$$.$getChildElementByAttributeValue$;
$goog$exportSymbol$$("AdfSubIdUtils.getChildElementByAttributeValue", $AdfSubIdUtils$$.$getChildElementByAttributeValue$);
$AdfSubIdUtils$$.$getChildElementsByAttributeValue$ = function $$AdfSubIdUtils$$$$getChildElementsByAttributeValue$$($domElement$$713$$, $attrName$$17$$, $attrValue$$30$$, $tagName$$26$$) {
  return $AdfDomUtils$$.$getChildElementsByAttributeValue$($domElement$$713$$, $attrName$$17$$, $attrValue$$30$$, $tagName$$26$$);
};
$AdfSubIdUtils$$.getChildElementsByAttributeValue = $AdfSubIdUtils$$.$getChildElementsByAttributeValue$;
$goog$exportSymbol$$("AdfSubIdUtils.getChildElementsByAttributeValue", $AdfSubIdUtils$$.$getChildElementsByAttributeValue$);
$AdfSubIdUtils$$.$getChildElementByValueMap$ = function $$AdfSubIdUtils$$$$getChildElementByValueMap$$($domElement$$714$$, $keyValueArray$$1$$, $tagName$$27$$) {
  return $AdfDomUtils$$.$getChildElementByValueMap$($domElement$$714$$, $keyValueArray$$1$$, $tagName$$27$$);
};
$AdfSubIdUtils$$.getChildElementByValueMap = $AdfSubIdUtils$$.$getChildElementByValueMap$;
$goog$exportSymbol$$("AdfSubIdUtils.getChildElementByValueMap", $AdfSubIdUtils$$.$getChildElementByValueMap$);
